/* Most    (c) Alex Tweedly  1986  -  tuned for MWC - CJPurcell - 28 Jan '87 */
#include <stdio.h>                                    /**** INCLUDE FILES ****/
#include <ctype.h>
#include <osbind.h>

#define TRUE    1                                 /* General purpose defines */
#define FALSE   0
#define FOREVER for (;;)
                                                         /* program specific */
#define NBYTE (256)                 /* allocation boundary for graphic pages */
#define LINELEN   80
#define NOCHANGE -1L
#define SAMEREZ  -1
FILE *in;
char *sc0, *sc1, *sc2;
char filename[32];

read_page()                  /* FUNCTION */
{
   int i ;
   register char *p;
   register int c;
   char buf[LINELEN];

   Cconws("\027\033E");           /* Clear screen */
   for (i=0; i<24; i++)
   { 
     if ( (p = fgets( buf, LINELEN, in) ) == NULL )
     {
       Cconws("\r\n-End-of-File-");
       return(TRUE);
     }
     while ( (c = (int) *p++) != 0) Bconout(2, c); 
     Cconws("\r");
   }
   Cconws("\r\n R||Q||Any");
   return (FALSE);
}

cin(s)  register char *s;       /* FUNCTION */
{
   register char c;
   FOREVER
   {
     c = Cconin();  /* if RETURN, change to terminator and exit loop */
     if (c == 13)
     {
          *s++ = 0;
          exit();
     }
     *s++ = c;
   }
}

main(argc, argv) char **argv; int argc;
{
  char *maladdr ;
  char *temp , reply ;
  int needname, new_done ;
  int done = 0 ;

  sc0 = sc1 = Logbase();                /* use existing system page memory */
  maladdr = ( char *) Malloc ((long) ((32000L) + NBYTE)) ;
  sc2     = ( char *) (((long) maladdr + 0x00ffL) & ~(0x00ffL));

  if (argc >= 2) 
  {
     strcpy( filename, argv[1] );
     needname =  FALSE ;
  }
  else needname =  TRUE ;

  Setscreen(sc1, sc1, SAMEREZ);    /* Clear screen */
  Cconws("\027\033E");
 
  if ( needname )
  {
    Cconws("\027\033e");                  /* Enable cursor */
    Cconws(" Enter file name : ");
    cin( filename );
  }
  in = fopen(filename, "r");
  if (in == NULL) 
  {
    Cconws(" File '");
    Cconws( filename );
    Cconws("' cannot be opened for reading.");
    Cconws("\r\n");
    Cconws("press any key to continue");
    Bconin(2);
    goto finish;
  }
restart:
  done = read_page();
  FOREVER
  {
    /* display screen 1, prepare to format other */
    Setscreen(sc2, sc1, SAMEREZ);
    if ( done == 0 ) new_done = read_page();
    reply = (int) Cconin() ;
    if (( reply == 'q' ) || ( reply == 'Q' )) break;
    if (( reply == 'R' ) || ( reply == 'r' ))
    {                                           /* Restart */
      rewind( in );            /* now we must swap screens */
      temp = sc1;
       sc1 = sc2;
       sc2 = temp;
      goto restart;
    }
    if (done) break;
    temp = sc1;                 /* otherwise: swap screens */
     sc1 = sc2;
     sc2 = temp;
    done = new_done;
  }
finish:                  /* and return to displaying the system screen */
                          /* change to outputting to the system screen */
  Setscreen(sc0, sc1, SAMEREZ);             /* clear the system screen */
  Cconws("\027\033E");
  Setscreen(sc0, sc0, SAMEREZ);
  Mfree(maladdr);                           /* Free up allocated memory*/
}
/* List of utilized symbols as complied by MWC 31 Jan'87 :
00000000 SI _start_
00000110 SI read_page_
000001BC SI cin_
000001FA SI main_
00000486 SI strcpy_
00000496 SI fgets_
000004E8 SI fgetc_
0000052E SI fopen_
00000582 SI rewind_
000005A8 SI fseek_
00000616 SI _fopen_
000007B2 SI finit_
000008B8 SI _fginit_
000008E2 SI _fpinit_
00000912 SI _finish_
00000944 SI fclose_
000009AA SI fflush_
00000A42 SI _fgetb_
00000B08 SI _fgetc_
00000B8C SI _fputb_
00000BD8 SI _fputc_
00000C54 SI _fputt_
00000CB6 SI _fpseek_
00000D2A SI exit_
00000D44 SI _exit_
00000D5C SI close_
00000DAC SI creat_
00000E34 SI dup_
00000E8C SI dup2_
00000EEE SI isatty_
00000F0E SI lseek_
00000F3A SI open_
00000FC6 SI read_
000010E6 SI _isdrv_
0000116E SI stat_
00001308 SI write_
00001338 SI _getfhtype_
00001392 SI _setfhtype_
000013C8 SI _aliasfh_
00001434 SI _seterrno_
00001456 SI tdtotime_
00001552 SI timetotd_
000015B6 SI bdos_
000015B6 SI gemdos_
000015D6 SI xbios_
000015E6 SI vlmul
000015EE SI vrmul
000015C6 SI bios_
0000160A SI settz_
000017FA SI localtime_
000017DC SI ctime_
0000186C SI asctime_
00001A3A SI gmtime_
00001BB4 SI isleapyear_
00001C08 SI dayspermonth_
00001D86 SI getenv_
00001F74 SI malloc_
00001F8C SI free_
00001FF2 SI lsbrk_
00001E78 SI lmalloc_
00002048 SI sbrk_
00002060 SI lldiv
00002066 SI lrdiv
000020A4 SI llmul
000020AC SI lrmul
000020DA SI llrem
000020E0 SI lrrem
00002110 SI vdiv
00002134 SI vmul
00002152 SI atoi_
000021DC PD errno_
000021DE PD environ_
0000226C PD _fp_
000022BC PD _stdin_
000022D6 PD _stdout_
000022F0 PD _stderr_
00002312 PD _iovector_
00002364 PD _cmdname_
0000236A PD _stksize_
0000236E PD timezone_
00002372 PD tzname_
000023B2 PD tzdstdef_
00002446 PD _a_scanp_
0000244A PD _a_first_
0000252E BD filename_
0000254E BD sc0_
00002552 BD sc1_
00002556 BD sc2_
0000255A BD in_                                  Why so many?  CJP    */
